<i18n>
{
  "fr": {
    "title": "Les véhicules (véhicules routiers, bateaux ou encore aéronefs)",
    "save-msg": "Les informations de véhicules ont été sauvegardées avec <strong><span style='color:green;'>succès</span></strong>.",
    "info-1": "Définissez l'ensemble des véhicules utilisés par le laboratoire ou loués en",
    "info-2": "dans le cadre d’un contrat de leasing, en dehors des véhicules inclus dans les frais des missions.",
    "info-3": "Lorsque des véhicules sont mutualisés entre plusieurs entités (laboratoires, universités ou autres), chaque entité prend 'sa part' des kms parcourus ou des litres de carburant consommés, soit sur une base comptable si vous avez les dépenses réelles, soit avec une estimation 'à la louche' de l'emprunt par chaque entité des véhicules (en nombre de jours sur l'année par exemple). Il convient de se mettre d’accord entre entités sur la répartition des kms ou des litres consommés, afin d'éviter d’éventuels doubles comptages ou omissions.",
    "no-vehicle": "Aucun véhicule",
    "delete-msg": "Êtes vous sûr de vouloir supprimer le véhicule",
    "hours": "heures"
  },
  "en": {
    "title": "Vehicles (road vehicles, ships, aircraft)",
    "save-msg": "The data relating to the vehicles have been <strong><span style='color:green;'>successfully</span></strong>saved.",
    "info-1": "Enter all the vehicles used or leased in",
    "info-2": "within a lease agreement, excluding vehicles accounted for in the business trip bills",
    "info-3": "When vehicles are shared between several entities (laboratories, universities or any other entity), each entity reports its own share of the distances traveled or of the fuel consumed, either from data of the accounting system if you can have access to real expenses, or from a rough estimate of the use of the vehicle by each entity (e.g. number of days per year). It is important to reach an agreement between the entities about the distribution of kms or liters consumed so as to avoid double counting or missing emissions.",
    "no-vehicle": "No vehicle",
    "delete-msg": "Are you sure you want to delete the vehicle?",
    "hours": "hours"
  }
}
</i18n>

<template>
  <div>
    <serveur-info :erreur="module.erreur" />
    <su-service :icon="'car'">
      <template #title>
        {{ $t('title') }}
      </template>
      <p>
        {{ $t('info-1') }} <strong>{{ GHGIyear }}</strong> {{ $t('info-2') }}
        <br />
        <br />
        {{ $t('info-3') }}
      </p>
    </su-service>
    <br />
    <b-table
      :data="vehicles"
      :striped="true"
      :narrowed="true"
      :hoverable="true"
      :sort-icon="'angle-up'"
      default-sort="name"
    >
      <b-table-column
        :label="$t('id')"
        field="name"
        sortable
        v-slot="props"
      >
        {{ props.row.name }}
      </b-table-column>
      <b-table-column
        :label="$t('type')"
        field="type"
        sortable
        v-slot="props"
      >
        <b-icon
          :pack="typeIconPack(props.row.type)"
          :icon="typeIcon(props.row.type)"
          style="padding-right: 20px"
        /> {{ $t(props.row.type) }}
      </b-table-column>
      <b-table-column
        :label="$t('engine')"
        field="engine"
        sortable
        v-slot="props"
      >
        {{ $t(props.row.engine) }}
      </b-table-column>
      <b-table-column
        :label="$t('consumption')"
        field="unit"
        numeric
        sortable
        v-slot="props"
      >
        {{ props.row.getConsumption() }}
        <span v-if="props.row.type==='aircraft'">({{ $t('hours') }})</span>
        <span v-else>({{ props.row.unit }})</span>
      </b-table-column>
      <b-table-column width="120" v-slot="props">
        <div class="panel-block">
          <b-tooltip
            v-if="submitted"
            :label="$t('display')"
            type="is-black"
          >
            <b-button
              size="is-small"
              icon-left="search"
              @click="edit(props.row)"
            />
          </b-tooltip>
          <b-tooltip
            v-else
            :label="$t('edit')"
            type="is-black"
          >
            <b-button
              size="is-small"
              icon-left="pencil"
              @click="edit(props.row)"
            />
          </b-tooltip>
          <b-tooltip
            :label="$t('delete')"
            type="is-black"
          >
            <b-button
              size="is-small"
              icon-left="trash"
              :disabled="submitted"
              @click="del(props.row)"
            />
          </b-tooltip>
        </div>
      </b-table-column>
      <section slot="empty" class="section">
        <div class="content has-text-grey has-text-centered">
          <p>
            <i class="sui sui-ban" style="font-size: 64px;"></i>
          </p>
          <p>{{ $t('no-vehicle') }}</p>
        </div>
      </section>
    </b-table>
    <vehicle-modal
      v-if="vehicle!==null"
      :displayModal="displayModal"
      :vehicle="vehicle"
      :vehicles="vehicles"
      :modeCreation="modeCreation"
      @close="closeModal"
      @update="update"
      @add="add"
    />
    <br />
    <nav class="level">
      <div class="level-left"></div>
      <div class="level-right">
        <div class="buttons">
          <b-button
            class="button"
            icon-left="plus"
            :disabled="submitted"
            @click="displayAddForm()"
          >
            {{ $t('add') }}
          </b-button>
          <b-button
            class="level-item"
            :icon-left="validSavedIcon"
            :disabled="!module.isModified"
            type="is-primary"
            @click="valider()"
          >
            <span v-if="isAuthenticated">{{ $t('save') }}</span>
            <span v-else>{{ $t('validate') }}</span>
          </b-button>
        </div>
      </div>
    </nav>
  </div>
</template>

<script>
import Vehicle from '@/models/carbon/Vehicle.js'
import { mapGetters } from 'vuex'

const DEFAULT_TYPE = 'car'
const DEFAULT_ENGINE = 'gasoline'
const DEFAULT_UNIT = 'km'
const DEFAULT_NOENGINE = 1

export default {
  name: 'Vehicles',
  components: {
    'su-service': () => import('@/components/SUService.vue'),
    'serveur-info': () => import('@/components/ServeurInfo.vue'),
    'vehicle-modal': () => import('@/components/carbon/forms/VehicleModal.vue')
  },
  $_veeValidate: {
    validator: 'new'
  },
  data () {
    return {
      modeCreation: false,
      displayModal: false,
      vehicle: null
    }
  },
  computed: {
    ...mapGetters('authentication', ['isAuthenticated']),
    validSavedIcon: function () {
      let icon = null
      if (this.isAuthenticated) {
        icon = 'save'
      } else {
        icon = 'check'
      }
      return icon
    },
    submitted: function () {
      return this.$store.getters['ghgi/item']['vehiclesSubmitted']
    },
    GHGIyear: function () {
      return this.$store.getters['ghgi/item']['year']
    },
    vehicles: function () {
      return this.$store.getters['vehicles/items']
    },
    module: function () {
      return this.$store.getters['vehicles/module']
    }
  },
  methods: {
    typeIcon: function (type) {
      return Vehicle.getIcon(type)
    },
    typeIconPack: function (type) {
      return Vehicle.getIconPack(type)
    },
    valider: function () {
      if (this.isAuthenticated) {
        const loadingComponent = this.$buefy.loading.open({
          container: null
        })
        this.$store.dispatch('vehicles/save')
          .then(data => {
            loadingComponent.close()
            if (this.vehicles.length === 0) {
              this.$store.commit('vehicles/ISVALID', false)
            } else {
              this.$store.commit('vehicles/ISVALID', true)
            }
            this.$store.commit('vehicles/ERREUR', '')
            this.$store.commit('vehicles/ISMODIFIED', false)
            window.scrollTo(0, 0)
            this.$buefy.toast.open({
              type: 'is-light',
              message: this.$t('save-msg')
            })
          })
          .catch((erreur) => {
            loadingComponent.close()
            this.$store.commit('vehicles/ISVALID', false)
            this.$store.commit('vehicles/ERREUR', erreur.response.data)
          })
      } else {
        if (this.vehicles.length === 0) {
          this.$store.commit('vehicles/ISVALID', false)
        } else {
          this.$store.commit('vehicles/ISVALID', true)
        }
        this.$store.commit('vehicles/ISMODIFIED', false)
      }
    },
    displayAddForm: function () {
      this.modeCreation = true
      this.vehicle = new Vehicle(
        null,
        DEFAULT_TYPE,
        '',
        DEFAULT_ENGINE,
        {
          id: null,
          january: 0,
          february: 0,
          march: 0,
          april: 0,
          may: 0,
          june: 0,
          july: 0,
          august: 0,
          septembre: 0,
          octobre: 0,
          novembre: 0,
          decembre: 0,
          total: 0,
          isMonthly: true
        },
        DEFAULT_UNIT,
        0,
        DEFAULT_NOENGINE,
        0,
        true
      )
      this.displayModal = true
    },
    closeModal: function () {
      this.displayModal = false
      this.vehicle = null
    },
    add: function (vehicle) {
      this.$store.dispatch('vehicles/add', vehicle)
      this.$store.commit('vehicles/ISMODIFIED', true)
      this.closeModal()
    },
    update: function (obj) {
      this.$store.dispatch('vehicles/update', obj)
      this.$store.commit('vehicles/ISMODIFIED', true)
      this.closeModal()
    },
    edit: function (vehicle) {
      this.modeCreation = false
      this.vehicle = vehicle
      this.displayModal = true
    },
    del: function (vehicle) {
      let self = this
      this.$buefy.dialog.confirm({
        title: self.$t('delete') + ' "' + vehicle.name + '"',
        message: self.$t('delete-msg') + ' <b>' + vehicle.name + '</br>?',
        confirmText: self.$t('validate'),
        cancelText: self.$t('cancel'),
        canCancel: ['escape', 'button', 'outside'],
        onConfirm: function () {
          self.$store.dispatch('vehicles/delete', vehicle)
          self.$store.commit('vehicles/ISMODIFIED', true)
        }
      })
    }
  }
}
</script>

<style>
.table td {
  vertical-align: middle !important;
}
</style>
